package cn.newfeifan.mall.module.product.service.spuapply;

import javax.validation.*;

import cn.newfeifan.mall.module.product.controller.admin.spu.vo.ProductSpuUpdateStatusReqVO;
import cn.newfeifan.mall.module.product.controller.admin.spuapply.vo.*;
import cn.newfeifan.mall.module.product.dal.dataobject.spuapply.SpuApplyDO;
import cn.newfeifan.mall.framework.common.pojo.PageResult;


/**
 * 商品spu申请 Service 接口
 *
 * @author 非繁人
 */
public interface SpuApplyService {

    /**
     * 创建商品spu申请
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createSpuApply(@Valid SpuApplySaveReqVO createReqVO);

    /**
     * 更新商品spu申请
     *
     * @param updateReqVO 更新信息
     */
    void updateSpuApply(@Valid SpuApplySaveReqVO updateReqVO);

    /**
     * 删除商品spu申请
     *
     * @param id 编号
     */
    void deleteSpuApply(Long id);

    /**
     * 获得商品spu申请
     *
     * @param id 编号
     * @return 商品spu申请
     */
    SpuApplyDO getSpuApply(Long id);

    /**
     * 获得商品spu申请分页
     *
     * @param pageReqVO 分页查询
     * @return 商品spu申请分页
     */
    PageResult<SpuApplyDO> getSpuApplyPage(SpuApplyPageReqVO pageReqVO);

    /**
     * 获得商品 SPU 申请
     *
     * @param id 编号
     * @return 商品 SPU 申请
     */
    SpuApplyDO getSpu(Long id);

    /**
     * 获得商品 SPU 申请详情
     * @param id id
     * @return 申请详情
     */
    SpuApplyRespVO getSpuApplyDetail(Long id);

    /**
     * 更新 SPU 状态
     *
     * @param updateReqVO 更新请求
     */
    void updateSpuStatus(ProductSpuUpdateStatusReqVO updateReqVO);
}